//  gmodconfig - a Gnome based kernel module configuration tool
//  http://gmodconfig.sourceforge.net/
//  Copyright (C) 2003 Cyril Bortolato
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  gmodapp.h: main application' interface
//--------------------------------------------------------------------------//

#ifndef gmodapp_h
#define gmodapp_h

#include <gnome.h>
#include <string>
using std::string;

namespace gmodcfg {

class Module;
class ModulesConfManager;
class ModuleGuiBuilder;
class ModuleInfoReader;

class Application
{
		GtkWidget* TopWidget;
		GtkTreeView* TreeView;
        GnomeAppBar* StatusBar;
		string ModulesPath, ModulesConfFile;
        ModulesConfManager* ModConfMgr;
        ModuleGuiBuilder* ModGuiMgr;
        ModuleInfoReader* ModInfoReader;
        string Locale;
        int Verbosity;

        void storeCurrentModuleSettings();
        Application( const Application& );
        Application& operator=( const Application& );

	public:
		Application( const string& modpath, const string& modConfFile,
                     const string& language="en", int verbosity=0 );
        ~Application();

		void Start();
        void Quit();

        const Module* GetModuleInfo( const string& ) const;
		void BuildModuleGui( const Module* mod );

        // main GUI actions
        void DiscardChanges();
        void SaveAllOptions();
        void ApplyOptions() const;
        void ShowAboutBox() const;

        const string& GetLocale() const { return Locale; }
};

};

#endif
